function dots = HC_model_sim(N1,F_in,e_in,F_over)
n_x = 12;
n_r = 12;
scaling_factor = 1e-2;

N = reshape(N1(1:n_r*n_x),n_r,n_x)*scaling_factor;
dd = reshape(N1(n_r*n_x+1:2*n_r*n_x),n_r,n_x)*1e-6;
v_theta = reshape(N1(2*n_r*n_x+1:3*n_r*n_x),n_r,n_x);

F_under = F_in - F_over; 
R_o = 0.05;
R_i = 0.025;
R_c = 0.25*R_o; % Rankine vortex
C_decay = 0.04; % Swirl decay
L = 1.7; % Length of the separator
dL = L/n_x;
v_zb = F_in/pi/R_o^2;
Omega = 2.5; % Swirl number
v_theta_max = Omega * v_zb;

if v_theta_max <= 4.45
    dd_in = (-107*v_theta_max + 600)*1e-6;
else
    dd_in = (-8*v_theta_max + 160)*1e-6;
end

% Vd = pi*dd_in^3/6;
% nd_in = e_in/Vd;

%%
v_theta_dot = zeros(n_r,n_x);
 j = 1;
 i = 1;
v_theta_inner = 0;
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
v_theta_i = v_theta_in(i,v_theta_max,R_c,R_o,n_r);
v_theta_dot(i,j) = -v_x_left*(v_theta(i,j) - v_theta_i)/(dL/2) - C_decay/2/R_o*v_theta(i,j)*v_x_left; 
 
for i = 2:n_r-1
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
v_theta_i = v_theta_in(i,v_theta_max,R_c,R_o,n_r);
v_theta_dot(i,j) = -v_x_left*(v_theta(i,j) - v_theta_i)/(dL/2) - C_decay/2/R_o*v_theta(i,j)*v_x_left;
end

i = n_r;
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = 0;   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i,j));
v_theta_i = v_theta_in(i,v_theta_max,R_c,R_o,n_r);
v_theta_dot(i,j) = -v_x_left*(v_theta(i,j) - v_theta_i)/(dL/2) - C_decay/2/R_o*v_theta(i,j)*v_x_left;

for j = 2:n_x
     i = 1;
v_theta_inner = 0;
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
v_theta_dot(i,j) = -v_x_left*(v_theta(i,j) - v_theta(i,j-1))/(dL) - C_decay/2/R_o*v_theta(i,j)*v_x_left;     
     for i = 2:n_r-1
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
v_theta_dot(i,j) = -v_x_left*(v_theta(i,j) - v_theta(i,j-1))/(dL) - C_decay/2/R_o*v_theta(i,j)*v_x_left;
     end
     i = n_r;
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = 0;   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i,j));
v_theta_dot(i,j) = -v_x_left*(v_theta(i,j) - v_theta(i,j-1))/(dL) - C_decay/2/R_o*v_theta(i,j)*v_x_left;
end


%%
dd_dot = zeros(n_r,n_x);
 j = 1;
 i = 1;
v_theta_inner = 0;
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
dd_dot(i,j) = -v_x_left*(dd(i,j) - dd_in)/(dL/2); 
 
for i = 2:n_r-1
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
dd_dot(i,j) = -v_x_left*(dd(i,j) - dd_in)/(dL/2);
end
i = n_r;
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = 0;   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i,j));
dd_dot(i,j) = -v_x_left*(dd(i,j) - dd_in)/(dL/2);


for j = 2:n_x
     i = 1;
v_theta_inner = 0;
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
dd_dot(i,j) = -v_x_left*(dd(i,j) - dd(i,j-1))/(dL);     
     for i = 2:n_r-1
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
dd_dot(i,j) = -v_x_left*(dd(i,j) - dd(i,j-1))/(dL);
     end
     i = n_r;
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = 0;   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i,j));
dd_dot(i,j) = -v_x_left*(dd(i,j) - dd(i,j-1))/(dL);
 end


%%
j = 1;
i = 1;
v_theta_inner = 0;
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
N_dot(i,j) = Ac_outer*v_r_outer*N(i+1,j)/dV + (v_x_left*e_in - v_x_right*N(i,j))/dL;
% N_dot(i,j) = Ac_outer*v_r_outer*N(i+1,j)/dV*min(max((1- Vd*N(i,j)),0),1) + (v_x_left*nd_in - v_x_right*N(i,j)*min(max((1- Vd*N(i,j+1)),0),1))/dL;
for i = 2:n_r-1
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
N_dot(i,j) = (Ac_outer*v_r_outer*N(i+1,j) - Ac_inner*v_r_inner*N(i,j))/dV + (v_x_left*e_in - v_x_right*N(i,j))/dL;
% N_dot(i,j) = (Ac_outer*v_r_outer*N(i+1,j)*min(max((1- Vd*N(i,j)),0),1) - Ac_inner*v_r_inner*N(i,j)*min(max((1- Vd*N(i-1,j)),0),1))/dV + (v_x_left*nd_in - v_x_right*N(i,j)*min(max((1- Vd*N(i,j+1)),0),1))/dL;
end
i = n_r;
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = 0;   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i,j));
N_dot(i,j) = -(Ac_inner*v_r_inner*N(i,j))/dV + (v_x_left*e_in - v_x_right*N(i,j))/dL;
% N_dot(i,j) = -(Ac_inner*v_r_inner*N(i,j))/dV *min(max((1- Vd*N(i-1,j)),0),1) + (v_x_left*nd_in - v_x_right*N(i,j)*min(max((1- Vd*N(i,j+1)),0),1))/dL;

for j = 2:n_x

i = 1;
v_theta_inner = 0;
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
N_dot(i,j) = Ac_outer*v_r_outer*N(i+1,j)/dV + (v_x_left*N(i,j-1) - v_x_right*N(i,j))/dL;
% N_dot(i,j) = Ac_outer*v_r_outer*N(i+1,j)/dV *min(max((1- Vd*N(i,j)),0),1) + (v_x_left*N(i,j-1)*min(max((1- Vd*N(i,j)),0),1) - v_x_right*N(i,j)*min(max((1- Vd*N(i,j+1)),0),1))/dL;

for i = 2:n_r-1
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = (v_theta(i,j)*(sqrt(i/n_r)-sqrt((i-1)/n_r)) + v_theta(i+1,j)*(sqrt((i+1)/n_r)-sqrt((i)/n_r)))/(sqrt((i+1)/n_r)-sqrt((i-1)/n_r));   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i+1,j));
N_dot(i,j) = (Ac_outer*v_r_outer*N(i+1,j)-Ac_inner*v_r_inner*N(i,j))/dV + (v_x_left*N(i,j-1) - v_x_right*N(i,j))/dL;  
% N_dot(i,j) = (Ac_outer*v_r_outer*N(i+1,j)*min(max((1- Vd*N(i,j)),0),1)-Ac_inner*v_r_inner*N(i,j)*min(max((1- Vd*N(i-1,j)),0),1))/dV + (v_x_left*N(i,j-1)*min(max((1- Vd*N(i,j)),0),1) - v_x_right*N(i,j)*min(max((1- Vd*N(i,j+1)),0),1))/dL; 
end

i = n_r;
v_theta_inner = (v_theta(i-1,j)*(sqrt((i-1)/n_r)-sqrt((i-2)/n_r)) + v_theta(i,j)*(sqrt((i)/n_r)-sqrt((i-1)/n_r)))/(sqrt((i)/n_r)-sqrt((i-2)/n_r));
v_theta_outer = 0;   
[Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,R_i,R_o,L,n_r,n_x,F_in,F_over,v_theta_inner,v_theta_outer,dd(i,j),dd(i,j));
N_dot(i,j) = -(Ac_inner*v_r_inner*N(i,j))/dV + (v_x_left*N(i,j-1) - v_x_right*N(i,j))/dL;
% N_dot(i,j) = -(Ac_inner*v_r_inner*N(i,j))/dV*min(max((1- Vd*N(i-1,j)),0),1)+ (v_x_left*N(i,j-1)*min(max((1- Vd*N(i,j)),0),1) - v_x_right*N(i,j)*min(max((1- Vd*N(i,j+1)),0),1))/dL;
end

%%
% j = n_x;
% 
% i = 1;
% [Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,j,R_i,R_o,L,n_r,n_x,F_in,F_over,Omega,dd);
% N_dot(i,j) = Ac_outer*v_r_outer*N(i+1,j)/dV + (v_x_left*N(i,j-1) - v_x_right*N(i,j))/dL;
% % N_dot(i,j) = Ac_outer*v_r_outer*N(i+1,j)/dV *min(max((1- Vd*N(i,j)),0),1) + (v_x_left*N(i,j-1)*min(max((1- Vd*N(i,j)),0),1)- v_x_right*N(i,j))/dL;
% 
% for i = 2:n_r-1
% [Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,j,R_i,R_o,L,n_r,n_x,F_in,F_over,Omega,dd);
% N_dot(i,j) = (Ac_outer*v_r_outer*N(i+1,j)-Ac_inner*v_r_inner*N(i,j))/dV + (v_x_left*N(i,j-1) - v_x_right*N(i,j))/dL;  
% % N_dot(i,j) = (Ac_outer*v_r_outer*N(i+1,j)*min(max((1- Vd*N(i,j)),0),1)-Ac_inner*v_r_inner*N(i,j)*min(max((1- Vd*N(i-1,j)),0),1))/dV + (v_x_left*N(i,j-1)*min(max((1- Vd*N(i,j)),0),1) - v_x_right*N(i,j))/dL; 
% end
% 
% i = n_r;
% [Ac_outer,Ac_inner,Ax,v_r_inner,v_r_outer,v_x_left,v_x_right,dV] = area_vel_vol(i,j,R_i,R_o,L,n_r,n_x,F_in,F_over,Omega,dd);
% N_dot(i,j) = -(Ac_inner*v_r_inner*N(i,j))/dV + (v_x_left*N(i,j-1) - v_x_right*N(i,j))/dL;
% % N_dot(i,j) = -(Ac_inner*v_r_inner*N(i,j))/dV*min(max((1- Vd*N(i-1,j)),0),1) + (v_x_left*N(i,j-1)*min(max((1- Vd*N(i,j)),0),1) - v_x_right*N(i,j))/dL;


e_under_ideal = 0;
e_over_ideal = 0;

%%
j = n_x;
for i = 4:n_r
e_under_ideal = e_under_ideal  + N(i,j)/9; 
end

for i = 1:3
e_over_ideal = e_over_ideal  +  N(i,j)/3; 
end

%%
k_reen = 1e-6;
q_reen = k_reen*(F_under/pi/(R_o^2-R_i^2) - F_over/pi/R_i^2);
e_under_real = ((F_under - q_reen)*e_under_ideal+(q_reen)*e_over_ideal)/F_under;
e_over_real = ((F_over - q_reen)*e_over_ideal+(q_reen)*e_under_ideal)/F_over;

dots = [reshape(N_dot,n_r*n_x,1)/scaling_factor; reshape(dd_dot,n_r*n_x,1)/1e-6; reshape(v_theta_dot,n_r*n_x,1); e_under_ideal*1e6; e_over_ideal*1e6; e_under_real*1e6; e_over_real*1e2];

