%clear
%close all
%load('dynamicresults')
tout=gs1_Y.time/3600;

set(0,'DefaultTextFontName','Times',...
'DefaultTextFontSize',25,...
'DefaultAxesFontName','Times',...
'DefaultAxesFontSize',25,...
'DefaultLineLineWidth',3,...
'DefaultLineMarkerSize',7.75)
disp('done')


%% gs1
%grid on
figure(13);



subplot(4,3,1)
plot(tout,3600*gs1_U.signals.values(:,1))
grid on
title('\bf{Gas flow out $F_{out}^{g}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
ylim(3600*[min(gs1_U.signals.values(:,1))-0.02 max(gs1_U.signals.values(:,1))+0.02])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,2400,'Case 2','Color','r');
text(19,2400,'Case 3','Color','k');
ht = text(3,2210,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(4,3,2)
plot(tout,3600*gs1_U.signals.values(:,2))
grid on
title('\bf{Oil flow out $F_{oil}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
ylim(3600*[min(gs1_U.signals.values(:,2))-0.005 max(gs1_U.signals.values(:,2))+0.005])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,1900,'Case 2','Color','r');
text(19,1900,'Case 3','Color','k');
ht = text(2,1900,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(4,3,3)
plot(tout,3600*gs1_U.signals.values(:,3))
grid on
title('\bf{Water flow out $F_{water}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
ylim(3600*[min(gs1_U.signals.values(:,3))-0.001 max(gs1_U.signals.values(:,3))+0.001])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,310,'Case 2','Color','r');
text(19,310,'Case 3','Color','k');
ht = text(2,290,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(4,3,4)
plot(tout,3600*simD.signals.values(:,1))
grid on
title('\bf{Gas flow in $F_{in}^{g}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
ylim(3600*[min(simD.signals.values(:,1))-0.02 max(simD.signals.values(:,1))+0.02])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,1700,'Case 2','Color','r');
text(19,1700,'Case 3','Color','k');
ht = text(3,1650,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(4,3,5)
plot(tout,3600*simD.signals.values(:,2))
grid on
title('\bf{Total liquid flow in $F_{in}^{l}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
ylim(3600*[min(simD.signals.values(:,2))-0.02 max(simD.signals.values(:,2))+0.02])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,2200,'Case 2','Color','r');
text(19,2200,'Case 3','Color','k');
ht = text(2,2200,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)

subplot(4,3,6)
plot(tout,simD.signals.values(:,3)*100)
grid on
title('\bf{Water cut in $\epsilon_{in}$ ($\%$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
ylim(100*[min(simD.signals.values(:,3))-0.005 max(simD.signals.values(:,3))+0.005])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,16,'Case 2','Color','r');
text(19,16,'Case 3','Color','k');
ht = text(2,15.5,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(4,3,7)
plot(tout,gs1_Y.signals.values(:,1))
grid on
%ylabel('Pressure (bar)')
title('\bf{Pressure $P_g$ ($bara$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim([min(gs1_Y.signals.values(:,1))-0.05 max(gs1_Y.signals.values(:,1))+0.05])
xlim([0 max(tout)])
yL = get(gca,'YLim');
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,8.05,'Case 2','Color','r');
text(19,8.05,'Case 3','Color','k');
ht = text(3,8.05,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



% xlabel('\it t ($h$)','Interpreter','latex')
% xlabel('t (h)')
 
subplot(4,3,8)
plot(tout,gs1_Y.signals.values(:,2))
grid on
title('\bf{Oil level $h_{oil}$ ($m$)}','interpreter','latex')
ylim([min(gs1_Y.signals.values(:,2))-0.01 max(gs1_Y.signals.values(:,2))+0.01])
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
xlim([0 max(tout)])
% xlabel('t (h)')
% xlabel('\it t ($h$)','Interpreter','latex')
yL = get(gca,'YLim');
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,2.225,'Case 2','Color','r');
text(19,2.225,'Case 3','Color','k');
ht = text(2,2.225,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(4,3,9)
plot(tout,gs1_Y.signals.values(:,3))
grid on
title('\bf{Water level $h_{water}$ ($m$)}','interpreter','latex')
% xlabel('t (h)')
ylim([min(gs1_Y.signals.values(:,3))-0.01 max(gs1_Y.signals.values(:,3))+0.01])
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1); 
text(7,1.8,'Case 2','Color','r');
text(21,1.8,'Case 3','Color','k');
ht = text(2,1.65,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(4,3,11)
plot(tout,gs1_Y.signals.values(:,4)*100)
grid on
title('\bf{Water in oil out $\%WiO^{GS}$}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
ylim(100*[min(gs1_Y.signals.values(:,4))-0.0005 max(gs1_Y.signals.values(:,4))+0.0005])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
 xlabel('\it t ($h$)','Interpreter','latex')
 line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,3,'Case 2','Color','r');
text(19,2.7,'Case 3','Color','k');
ht = text(2,2.6,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)

 
subplot(4,3,12)
plot(tout,gs1_Y.signals.values(:,5))
grid on
title('\bf{Oil in water out $ppm_{out}^{GS}$}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35  40 45 50 55])
yticks([240 250 260 270 280])
ylim([min(gs1_Y.signals.values(:,5))-5 max(gs1_Y.signals.values(:,5))+5])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,260,'Case 2','Color','r');
text(19,260,'Case 3','Color','k');
ht = text(2,245,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)

%print('-depsc2','-r600','c7-gs1.eps')


%% hc
%grid on
figure(15);


subplot(3,2,1)
plot(tout,3600*hc_U.signals.values(:,1)*3)
grid on
title('\bf{Overflow $F_{over}$ ($m^3/h$)}','interpreter','latex')
ylim([3600*3*min(hc_U.signals.values(:,1))-0.05  3600*3*max(hc_U.signals.values(:,1))+ 0.05])
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
yticks([4 4.5 5])
xlim([0 max(tout)])
% xlabel('t (h)')
yL = get(gca,'YLim');
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(6,4.7,'Case 2','Color','r');
text(21,4.7,'Case 3','Color','k');
text(34,4.06,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1,4.06,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,4.3,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



subplot(3,2,2)
plot(tout,3600*F_in_sim*3  - 3600*hc_U.signals.values(:,1)*3)
grid on
title('\bf{Underflow $F_{under}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim(3600*3*[min(F_in_sim-hc_U.signals.values(:,1))-0.001 max(F_in_sim-hc_U.signals.values(:,1))+0.001])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,320,'Case 2','Color','r');
text(19,300,'Case 3','Color','k');
text(34,260,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1,260,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
%text(34,260,'Oil level in gravity separator raised','Color','k', 'Rotation',90,'FontSize',8);
%text(146000/3600-1,260,'Water level in gravity separator reduced','Color','k', 'Rotation',90,'FontSize',8);
ht = text(2,300,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



subplot(3,2,3)
plot(tout,e_in_sim*1e6)
grid on
title('\bf{Oil in water in $ppm_{in}^{HC}$}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim([min(1e6*e_in_sim)-10 max(1e6*e_in_sim)+10])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(6,260,'Case 2','Color','r');
text(20,260,'Case 3','Color','k');
text(34,239,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1,239,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
%text(34,239,'Oil level in gravity separator raised','Color','k', 'Rotation',90,'FontSize',8);
%text(146000/3600-1,239,'Water level in gravity separator reduced','Color','k', 'Rotation',90,'FontSize',8);
ht = text(2,250,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



subplot(3,2,4)
plot(tout,3600*F_in_sim*3)
grid on
title('\bf{Total flow in $F_{in}^{HC}$ or $F_{water}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim(3600*3*[min(F_in_sim)-0.001/3 max(F_in_sim)+0.001/3])
xlim([0 max(tout)])
yL = get(gca,'YLim');
%  xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,310,'Case 2','Color','r');
text(19,300,'Case 3','Color','k');
text(34,270,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1,270,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
%text(34,270,'Oil level in gravity separator raised','Color','k', 'Rotation',90,'FontSize',8);
%text(146000/3600-1,270,'Water level in gravity separator reduced','Color','k', 'Rotation',90,'FontSize',8);
ht = text(2,280,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(3,2,5)
plot(tout,hc_Y.signals.values(:,1))
grid on
title('\bf{Oil cut in overflow $\%OC_{over}$}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim([min(hc_Y.signals.values(:,1))-0.03 max(hc_Y.signals.values(:,1))+0.03])
xlim([0 max(tout)])
yL = get(gca,'YLim');
xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(8,1.6,'Case 2','Color','r');
text(22,1.6,'Case 3','Color','k');
text(34,1.48,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1,1.48,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
% text(34,1.48,'Oil level in gravity separator raised','Color','k', 'Rotation',90,'FontSize',8);
% text(146000/3600-1,1.48,'Water level in gravity separator reduced','Color','k', 'Rotation',90,'FontSize',8);
ht = text(2,1.5,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(3,2,6)
plot(tout,hc_Y.signals.values(:,2))
grid on
title('\bf{Oil in water out $ppm_{out}^{HC}$}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim([min(hc_Y.signals.values(:,2))-0.5 max(hc_Y.signals.values(:,2))+0.5])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
xlabel('\it t ($h$)','Interpreter','latex') 
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,20,'Case 2','Color','r');
text(19,20,'Case 3','Color','k');
text(34,18.8,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1,18.8,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
% text(34,18.8,'Oil level in gravity separator raised','Color','k', 'Rotation',90,'FontSize',8);
% text(146000/3600-1,18.8,'Water level in gravity separator reduced','Color','k', 'Rotation',90,'FontSize',8);
ht = text(2,21,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)

%print('-depsc2','-r600','c7-hc.eps')


%% cfu
%grid on
figure(16);

subplot(3,3,1)
plot(tout,F_reject1*4)
grid on
title('\bf{Reject flow $F_{reject}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
%yticks([40 50 60 80])
ylim([min(F_reject1*4)-0.3 max(F_reject1*4)+0.3])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,4,'Case 2','Color','r');
text(19,4,'Case 3','Color','k');
text(33.5,1.2,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,1.2,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,2,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



subplot(3,3,2)
plot(tout,F_out1*4)
grid on
title('\bf{Water outflow $F_{out}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
%yticks([300 325 350])
ylim([4*min(F_out1)-5 4*max(F_out1)+5])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,300,'Case 2','Color','r');
text(19,300,'Case 3','Color','k');
text(33.5,264,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,264,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,300,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



subplot(3,3,3)
plot(tout,F_flotation1*4)
grid on
title('\bf{Flotation gas flow $F_{float}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim([4*min(F_flotation1)-0.02 4*max(F_flotation1)+0.02])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,0.25,'Case 2','Color','r');
text(19,0.25,'Case 3','Color','k');
text(33.5,0.06,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,0.06,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,0.15,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



subplot(3,3,4)
plot(tout,F_in1*4)
grid on
title('\bf{Water inflow $F_{in}^{CFU}$ or $F_{under}$ ($m^3/h$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
%yticks([300 325 350])
ylim([4*min(F_in1)-5 4*max(F_in1)+5])
xlim([0 max(tout)])
text(5,310,'Case 2','Color','r');
text(19,310,'Case 3','Color','k');
text(33.5,265,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,265,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
yL = get(gca,'YLim');
% xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
ht = text(2,280,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)



subplot(3,3,5)
plot(tout,liq_hold_up1*100)
grid on
title('\bf{Liquid hold up $\alpha_l$ ($\%$)}','interpreter','latex')
ylim([min(liq_hold_up1*100)-1 max(liq_hold_up1*100)+1])
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
xlim([0 max(tout)])
% xlabel('t (h)')
yL = get(gca,'YLim');
%  xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,70,'Case 2','Color','r');
text(19,70,'Case 3','Color','k');
text(33.5,60.3,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,60.3,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,65,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(3,3,6)
plot(tout,ppm_in1)
grid on
title('\bf{Oil in water in $ppm_{in}^{CFU}$ or $ppm_{out}^{HC}$}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim([min(ppm_in1)-0.5 max(ppm_in1)+0.5])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,24,'Case 2','Color','r');
text(19,24,'Case 3','Color','k');
text(33.5,18.8,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,18.8,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,21,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(3,3,7)
plot(tout,Pressure1)
grid on
title('\bf{Pressure $P^{CFU}$ ($bara$)}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
%yticks([76.6 76.8 77 77.2 77.4])
ylim([min(Pressure1)-0.01 max(Pressure1)+0.01])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,1.02,'Case 2','Color','r');
text(19,1.02,'Case 3','Color','k');
text(33.5,0.976,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,0.976,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,1.01,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)

 
subplot(3,3,8)
plot(tout,gas_hold_up1*100)
grid on
title('\bf{Gas hold up top $\alpha_{gas}^{top}$ ($\%$)}','interpreter','latex')
ylim([min(gas_hold_up1*100)-0.25 max(gas_hold_up1*100)+0.25])
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
xlim([0 max(tout)])
% xlabel('t (h)')
yL = get(gca,'YLim');
 xlabel('\it t ($h$)','Interpreter','latex')
 line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(5,56,'Case 2','Color','r');
text(19,56,'Case 3','Color','k');
text(33.5,54.67,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,54.67,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,56,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


subplot(3,3,9)
plot(tout,ppm_out1)
grid on
title('\bf{Oil in water out $ppm_{out}^{CFU}$}','interpreter','latex')
xticks([0 5 10 15 20 25 30 35 40 45 50 55])
ylim([min(ppm_out1)-0.05 max(ppm_out1)+0.05])
xlim([0 max(tout)])
yL = get(gca,'YLim');
% xlabel('t (h)')
xlabel('\it t ($h$)','Interpreter','latex')
line([126000/3600  126000/3600],yL,'Color','g','LineStyle','--','LineWidth',1);
line([146000/3600  146000/3600],yL,'Color','m','LineStyle','--','LineWidth',1);
line([4  4],yL,'Color','r','LineStyle','--','LineWidth',1);
line([18  18],yL,'Color','k','LineStyle','--','LineWidth',1);
text(6,10.3,'Case 2','Color','r');
text(20,10.3,'Case 3','Color','k');
text(33.5,9.87,'$h_{oil}$ increased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
text(146000/3600-1.5,9.87,'$h_{water}$ decreased','Color','k', 'Rotation',90,'FontSize',18,'interpreter','latex');
ht = text(2,10.05,'Case 1','Color','b','FontSize',14);
set(ht,'Rotation',90)


%print('-depsc2','-r600','c7-cfuopt.eps')


