function v_t = stokesVelocity(rho_d,rho_c,mu_c,d_A)
% Calculates Stokes' terminal velocities of 10 different dispersed droplets
% rho_d:    Density of droplet phase
% rho_c:    Density of continuous phase
% mu_c:     Viscosity of continuous phase
% d_A:      Diameter of smallest droplet
d = (1:10).^(1/3)*d_A;              % Diameters of the 10 droplet sizes [m]
g = 9.81;                           % Gravity acceleration [m/s2]
v_t=(g*d.^2*(rho_d-rho_c)/(18*mu_c))';% Stokes terminal velocity [m/s]
end%fun