function [v_x,v_r] = velocity_calculator(R_i,R_o,F_in,F_over,v_theta,dd,r)

% Model constants
F_under = F_in - F_over;
rho_o = 881; % Oil density in kg/m^3
rho_w = 1064; % Brine density in kg/m^3
mu = 1e-3; % Viscosity of brine in Pa.s

if r <= R_i 
    v_x = F_over/pi/R_i^2;            % Center plug flow 
else
    v_x = F_under/pi/(R_o^2 - R_i^2); % Annular flow 
end

g_r = v_theta^2/r;                  % Radial acceleration
v_r = g_r*dd^2*(rho_w-rho_o)/18/mu; % Radial terminal velocity

