%% Initialize CasADi Model:
% Initializing casADi model equations and functions.
addpath('C:\Users\NOTADAS\Downloads\casadi-windows-matlabR2016a-v3.4.5');
import casadi.*

L = 5;
%k_int_o = 1;
k_int_o= 1.364878;
k_int_w= 0.235398;

% Parameters:
ns_tot_gs = ns_tot_gs-1; % no pressure in second stage separator states
nd = 1+10;
% nu = 2;



%% Definition of CasADi variables :
% X = SX.sym('x',ns_tot_gs,1);                   % States     
% X_dot= SX.sym('x_dot',ns_tot_gs,1);            % Change in states
% D = SX.sym('D',nd,1);                       % Disturbance
% U = SX.sym('U',nu,1);                       % System inputs 
X_gs2 = X(ns_gs1+1:ns_gs1+ns_gs2);
X_dot_gs2 = X_dot(ns_gs1+1:ns_gs1+ns_gs2);
% U_gs2 = U(nu_gs1+1:nu_gs1+nu_gs2);
D_gs2=[
    U_gs1(2);
    rho1_o(nx,1);
    rho2_o(nx,1);
    rho3_o(nx,1);
    rho4_o(nx,1);
    rho5_o(nx,1);
    rho6_o(nx,1);
    rho7_o(nx,1);
    rho8_o(nx,1);
    rho9_o(nx,1);
    rho10_o(nx,1)];
    


% OIL SIDE:
Xo = X_gs2(1:ns_o);
rho1_w = reshape(Xo(1:1*nz_o*nx),nx,nz_o); 
rho2_w = reshape(Xo(1*nz_o*nx+1:2*nz_o*nx),nx,nz_o); 
rho3_w = reshape(Xo(2*nz_o*nx+1:3*nz_o*nx),nx,nz_o); 
rho4_w = reshape(Xo(3*nz_o*nx+1:4*nz_o*nx),nx,nz_o);
rho5_w = reshape(Xo(4*nz_o*nx+1:5*nz_o*nx),nx,nz_o);
rho6_w = reshape(Xo(5*nz_o*nx+1:6*nz_o*nx),nx,nz_o); 
rho7_w = reshape(Xo(6*nz_o*nx+1:7*nz_o*nx),nx,nz_o); 
rho8_w = reshape(Xo(7*nz_o*nx+1:8*nz_o*nx),nx,nz_o); 
rho9_w = reshape(Xo(8*nz_o*nx+1:9*nz_o*nx),nx,nz_o); 
rho10_w= reshape(Xo(9*nz_o*nx+1:10*nz_o*nx),nx,nz_o);
Xo_dot = X_dot_gs2(1:ns_o);
rho1_dot_w = reshape(Xo_dot(1:1*nz_o*nx),nx,nz_o); 
rho2_dot_w = reshape(Xo_dot(1*nz_o*nx+1:2*nz_o*nx),nx,nz_o); 
rho3_dot_w = reshape(Xo_dot(2*nz_o*nx+1:3*nz_o*nx),nx,nz_o); 
rho4_dot_w = reshape(Xo_dot(3*nz_o*nx+1:4*nz_o*nx),nx,nz_o);
rho5_dot_w = reshape(Xo_dot(4*nz_o*nx+1:5*nz_o*nx),nx,nz_o);
rho6_dot_w = reshape(Xo_dot(5*nz_o*nx+1:6*nz_o*nx),nx,nz_o); 
rho7_dot_w = reshape(Xo_dot(6*nz_o*nx+1:7*nz_o*nx),nx,nz_o); 
rho8_dot_w = reshape(Xo_dot(7*nz_o*nx+1:8*nz_o*nx),nx,nz_o); 
rho9_dot_w = reshape(Xo_dot(8*nz_o*nx+1:9*nz_o*nx),nx,nz_o); 
rho10_dot_w= reshape(Xo_dot(9*nz_o*nx+1:10*nz_o*nx),nx,nz_o);
WC_o = (rho1_w + rho2_w + rho3_w + rho4_w + rho5_w ...
      + rho6_w + rho7_w + rho8_w + rho9_w + rho10_w)/rho_w;
                    
% WATER SIDE:
Xw = X_gs2(ns_o+1:ns_o+ns_w); 
rho1_o = reshape(Xw(1:1*nz_w*nx),nx,nz_w); 
rho2_o = reshape(Xw(1*nz_w*nx+1:2*nz_w*nx),nx,nz_w); 
rho3_o = reshape(Xw(2*nz_w*nx+1:3*nz_w*nx),nx,nz_w); 
rho4_o = reshape(Xw(3*nz_w*nx+1:4*nz_w*nx),nx,nz_w);
rho5_o = reshape(Xw(4*nz_w*nx+1:5*nz_w*nx),nx,nz_w);
rho6_o = reshape(Xw(5*nz_w*nx+1:6*nz_w*nx),nx,nz_w); 
rho7_o = reshape(Xw(6*nz_w*nx+1:7*nz_w*nx),nx,nz_w); 
rho8_o = reshape(Xw(7*nz_w*nx+1:8*nz_w*nx),nx,nz_w); 
rho9_o = reshape(Xw(8*nz_w*nx+1:9*nz_w*nx),nx,nz_w); 
rho10_o= reshape(Xw(9*nz_w*nx+1:10*nz_w*nx),nx,nz_w);
Xw_dot = X_dot_gs2(ns_o+1:ns_o+ns_w); 
rho1_dot_o = reshape(Xw_dot(1:1*nz_w*nx),nx,nz_w); 
rho2_dot_o = reshape(Xw_dot(1*nz_w*nx+1:2*nz_w*nx),nx,nz_w); 
rho3_dot_o = reshape(Xw_dot(2*nz_w*nx+1:3*nz_w*nx),nx,nz_w); 
rho4_dot_o = reshape(Xw_dot(3*nz_w*nx+1:4*nz_w*nx),nx,nz_w);
rho5_dot_o = reshape(Xw_dot(4*nz_w*nx+1:5*nz_w*nx),nx,nz_w);
rho6_dot_o = reshape(Xw_dot(5*nz_w*nx+1:6*nz_w*nx),nx,nz_w); 
rho7_dot_o = reshape(Xw_dot(6*nz_w*nx+1:7*nz_w*nx),nx,nz_w); 
rho8_dot_o = reshape(Xw_dot(7*nz_w*nx+1:8*nz_w*nx),nx,nz_w); 
rho9_dot_o = reshape(Xw_dot(8*nz_w*nx+1:9*nz_w*nx),nx,nz_w); 
rho10_dot_o= reshape(Xw_dot(9*nz_w*nx+1:10*nz_w*nx),nx,nz_w);
rho_oiw_tot= rho1_o + rho2_o + rho3_o + rho4_o + rho5_o ...
            +rho6_o + rho7_o + rho8_o + rho9_o + rho10_o;
WC_w = [1 - rho_oiw_tot(1:end-1,:)/rho_o; rho_oiw_tot(end,:)/rho_w];

% Other:
h_l  = X_gs2(ns_tot_gs-1);
h_lw = X_gs2(ns_tot_gs);
% P    = X(ns_tot-0);
% Fin_g = D(1);
Fin_l = D_gs2(1);
rhos_in = D_gs2(2:end);
% e_in  = D(3); 
d_A   = d_A_val;
% F = [0;U(1);U(2)];

%% Feed calculations
Fin_ws = (rhos_in/rho_w)*Fin_l; % volumetric flows of dispersed water in feed
Fin_w2wp = sum(Fin_ws*g_w_2);
Fin_w2op = (1-g_w_2)*Fin_ws;

Fin_w_tot = sum(Fin_ws);
Fin_o_tot = Fin_l-Fin_w_tot;
Fin_o2op = g_o_2*Fin_o_tot;
Fin_o2wp = (1-g_o_2)*Fin_o_tot;

Fin_wp = Fin_o2wp + Fin_w2wp;
Fin_op = Fin_o2op + sum(Fin_w2op);

rhosFeed_oilPhase = Fin_w2op*rho_w/Fin_op;
rhosFeed_waterPhase = [Fin_o2wp*rho_o/Fin_wp; zeros(9,1)];  


%% Geometric calculations
% Segment heights [m]
hs_o = (1:nz_o-1)'/(nz_o-1)*(h_w-h_lw) + h_lw ;
hs_w = (1:nz_w)'/nz_w*h_lw ;
hs = [hs_w;hs_o;h_l];

% Cross section areas [m2]
A_w = r^2*acos(1-h_w/r)-(r-h_w).*sqrt(h_w.*(2*r-h_w));
A_hs =  r^2*acos(1-hs/r)-(r-hs).*sqrt(hs.*(2*r-hs));
A_l = A_hs(nz_w+nz_o);
A_lw = A_hs(nz_w);
Ac_hs = A_hs-[0; A_hs(1:end-1)];
A_tank = pi*r^2;

% Horizontal transfer areas [m2]
At_o = 2*L/nx*sqrt(hs_o.*(2*r-hs_o));
At_w = 2*L/nx*sqrt(hs_w.*(2*r-hs_w));
A_int = At_w(end);
% A_int = 1;

% Control volumes [m3]
Vcv_w = Ac_hs(1:nz_w)*L/nx;                 % Under water level
Vcv_o = Ac_hs(nz_w+1:nz_w+nz_o-1)*L/nx;     % Over water level under weir
Vcv_top = Ac_hs(end)*L/nx;                  % Over weir

%% Coalescence of droplets to continuous phases:
i = 1:nx-2;
rhos_w = [rho1_w(i,1),rho2_w(i,1),rho3_w(i,1),rho4_w(i,1),rho5_w(i,1),...
    rho6_w(i,1),rho7_w(i,1),rho8_w(i,1),rho9_w(i,1),rho10_w(i,1)]';
rhos_o =[rho1_o(i,end),rho2_o(i,end),rho3_o(i,end),rho4_o(i,end),rho5_o(i,end),...
    rho6_o(i,end),rho7_o(i,end),rho8_o(i,end),rho9_o(i,end),rho10_o(i,end)]';

rateVec_water = (k_int_w*A_int*WC_o(i,1))';
rateVec_oil = (k_int_o*A_int*(1-WC_w(i,end)))';
rateMat_water = repmat(rateVec_water,10,1);
rateMat_oil = repmat(rateVec_oil,10,1);

m_coal_water = rhos_w.*rateMat_water; % Rate of mass, water to water phase 
m_coal_oil   = rhos_o.*rateMat_oil;   % Rate of mass, oil to oil phase 

%% Flow calculations:
% Calculating steady state product flows for given levels

% Interfacial volumetric flows [m3/s]:
F_int = (sum(m_coal_water)/rho_w - sum(m_coal_oil)/rho_o)';
Fint_sum = tril(ones(nx-2))'*F_int; % Reverse cumulative sum of F_int
F_int_tot = sum(F_int);             % Total flow 

% Calculated Product flows: (Steady state)
F = [0; Fin_l-(Fin_wp+F_int_tot); (Fin_wp+F_int_tot)];  % NO GAS FLOW
% Horizontal flows trough separator [m3/s]:
q_out = [ F(3)*Ac_hs(1:nz_w)/A_lw; 
          F(2)*Ac_hs(nz_w+1:nz_w+nz_o)/(A_l-A_lw)]; 
q_waterphase = repmat(q_out(1:nz_w),1,7) - (Ac_hs(1:nz_w)/A_lw)*Fint_sum';
q_oilphase = repmat(q_out(nz_w+1:nz_w+nz_o),1,7) + ...
              (Ac_hs(nz_w+1:nz_w+nz_o)/(A_l-A_lw))*Fint_sum';
q = [q_waterphase; q_oilphase]';
q = [q;q_out'];
% q gives the horizontal feed to each control volume left of the weir

% Change to real inlet flows:
q(1,1:nz_w)=Fin_wp*Ac_hs(1:nz_w)/A_lw;
q(1,nz_w+1:nz_w+nz_o) = Fin_op*Ac_hs(nz_w+1:nz_w+nz_o)/(A_l-A_lw);

%% Level calculations:
Vl_dot = Fin_l-F(2)-F(3);
hl_dot = 0*Vl_dot/(2*L*sqrt(h_l*(2*r-h_l)));    % multiplication with zero to kill the integrating states

Vlw_dot = Fin_wp + F_int_tot - F(3);
hlw_dot = 0*Vlw_dot/(2*L*(nx-1)/nx*sqrt(h_lw*(2*r-h_lw)));     % multiplication with zero to kill the integrating states

% Change in level result in changed control volumes:
j = (1:nz_w)';              % Water phase
    dAdt_water = 2*sqrt(hs(j).*(2*r-hs(j))).*(j)/nz_w*hlw_dot;
j = (nz_w+1:nz_w+nz_o-1)';  % Oil phase:
    dAdt_oil = 2*sqrt(hs(j).*(2*r-hs(j))).*(1-(j-nz_w)/(nz_o-1))*hlw_dot;
dAdt = [dAdt_water; dAdt_oil];
dVcvdt = L/nx*(dAdt-[0; dAdt(1:end-1)]);

%% Gas pressure calculations:
% m_g_in = Fin_g*rho_g;                               
% n_g_in = m_g_in/Mm_g;                   % Molar rate of gas in  [mol/s]
% n_g_out = P*1e5/(R_gas*T)*F(1);         % Molar rate of gas out [mol/s]
% V_l = L*A_l;                            % Total liquid volume   [m3]
% V_g = pi*r^2*L-V_l;                     % Total gas volume      [m3]
% P_dot = (R_gas*T/V_g*(n_g_in-n_g_out) + P*1e5/V_g*(Fin_l-F(2)-F(3)))*1e-5;

%% Density calculations:
v_stokes = -stokesVelocity(rho_o,rho_w,mu_w,d_A);

% % % % Main separator part, water phase
for j = 1:nz_w % Under water level:
for i = 1:nx-1 % Left of weir:
rhos = [rho1_o(i,j),rho2_o(i,j),rho3_o(i,j),rho4_o(i,j),rho5_o(i,j),...
        rho6_o(i,j),rho7_o(i,j),rho8_o(i,j),rho9_o(i,j),rho10_o(i,j)]';
R = rateOfFormation(rhos,k,rho_o);
v_adp_in = v_stokes*((WC_w(i,j)-0.7)/0.3)^n_adp;

if j == 1           % At bottom
rhos_Over=[rho1_o(i,j+1),rho2_o(i,j+1),rho3_o(i,j+1),rho4_o(i,j+1),rho5_o(i,j+1),...
           rho6_o(i,j+1),rho7_o(i,j+1),rho8_o(i,j+1),rho9_o(i,j+1),rho10_o(i,j+1)]';
v_adp_out = v_stokes*((WC_w(i,j+1)-0.7)/0.3)^n_adp;
elseif j == nz_w    % At interface
rhos_Under=[rho1_o(i,j-1),rho2_o(i,j-1),rho3_o(i,j-1),rho4_o(i,j-1),rho5_o(i,j-1),...
            rho6_o(i,j-1),rho7_o(i,j-1),rho8_o(i,j-1),rho9_o(i,j-1),rho10_o(i,j-1)]';
else
rhos_Over=[rho1_o(i,j+1),rho2_o(i,j+1),rho3_o(i,j+1),rho4_o(i,j+1),rho5_o(i,j+1),...
           rho6_o(i,j+1),rho7_o(i,j+1),rho8_o(i,j+1),rho9_o(i,j+1),rho10_o(i,j+1)]';    
rhos_Under=[rho1_o(i,j-1),rho2_o(i,j-1),rho3_o(i,j-1),rho4_o(i,j-1),rho5_o(i,j-1),...
            rho6_o(i,j-1),rho7_o(i,j-1),rho8_o(i,j-1),rho9_o(i,j-1),rho10_o(i,j-1)]';
v_adp_out = v_stokes*((WC_w(i,j+1)-0.7)/0.3)^n_adp;
end%if

if i == 1  % At separator inlet
  rhos_Left = rhosFeed_waterPhase;
else
  rhos_Left=[rho1_o(i-1,j),rho2_o(i-1,j),rho3_o(i-1,j),rho4_o(i-1,j),rho5_o(i-1,j),...
             rho6_o(i-1,j),rho7_o(i-1,j),rho8_o(i-1,j),rho9_o(i-1,j),rho10_o(i-1,j)]';
end%if

if i == nx-1 % at weir: (vertical convective flow)
  if j == nz_w % At interface
   rho_dots = (rhos_Left-rhos)*q_out(j)/Vcv_w(j) + R - rhos*dVcvdt(j)/Vcv_w(j);
  else
   rho_dots = (rhos_Left*q_out(j) + rhos_Over*sum(q_out(j+1:nz_w)))/Vcv_w(j) ...
            - rhos*sum(q_out(j:nz_w))/Vcv_w(j) + R - rhos*dVcvdt(j)/Vcv_w(j);
  end%if      
else % main part of separator
   rhos_Right = [rho1_o(i+1,j),rho2_o(i+1,j),rho3_o(i+1,j),rho4_o(i+1,j),rho5_o(i+1,j),...
       rho6_o(i+1,j),rho7_o(i+1,j),rho8_o(i+1,j),rho9_o(i+1,j),rho10_o(i+1,j)]';
   conv_trans = rhos_Left*max(q(i,j),0)  - rhos*max(q(i+1,j),0) ...
              + rhos_Right*max(-q(i,j),0)- rhos*max(-q(i+1,j),0);
  if j == nz_w % At interface
 rho_dots=  (                     conv_trans              )/Vcv_w(j)...
    + ( rhos_Under.*v_adp_in*At_w(j-1) - m_coal_oil(:,i)  )/Vcv_w(j)...
    + (                    R*Vcv_w(j)  - rhos*dVcvdt(j)   )/Vcv_w(j);
  elseif j == 1 % At bottom
 rho_dots=   (                        conv_trans          )/Vcv_w(j)...
            +(                  - rhos.*v_adp_out*At_w(j) )/Vcv_w(j)...
            +(     R*Vcv_w(j)   - rhos*dVcvdt(j)          )/Vcv_w(j);
  else
 rho_dots=   (                  conv_trans                   )/Vcv_w(j)...
   +(rhos_Under.*v_adp_in*At_w(j-1) - rhos.*v_adp_out*At_w(j))/Vcv_w(j)...
            +(         R*Vcv_w(j)   - rhos*dVcvdt(j)         )/Vcv_w(j);
  end%if
end%if
rho1_dot_o(i,j) = rho_dots(1);
rho2_dot_o(i,j) = rho_dots(2);
rho3_dot_o(i,j) = rho_dots(3);
rho4_dot_o(i,j) = rho_dots(4);
rho5_dot_o(i,j) = rho_dots(5);
rho6_dot_o(i,j) = rho_dots(6);
rho7_dot_o(i,j) = rho_dots(7);
rho8_dot_o(i,j) = rho_dots(8);
rho9_dot_o(i,j) = rho_dots(9);
rho10_dot_o(i,j) = rho_dots(10);    
end
end

% % % % Main separator part, Oil phase
v_stokes = stokesVelocity(rho_w,rho_o,mu_o,d_A);
for j = 1:nz_o-1 % Under weir:
for i = 1:nx-1 % Left of weir:
rhos = [rho1_w(i,j),rho2_w(i,j),rho3_w(i,j),rho4_w(i,j),rho5_w(i,j),...
        rho6_w(i,j),rho7_w(i,j),rho8_w(i,j),rho9_w(i,j),rho10_w(i,j)]';
rhos_Over=[rho1_w(i,j+1),rho2_w(i,j+1),rho3_w(i,j+1),rho4_w(i,j+1),rho5_w(i,j+1),...
        rho6_w(i,j+1),rho7_w(i,j+1),rho8_w(i,j+1),rho9_w(i,j+1),rho10_w(i,j+1)]';
R = rateOfFormation(rhos,k,rho_w);
v_adp_in = v_stokes*((0.7-WC_o(i,j))/0.7)^n_adp;

if i == 1
  rhos_Left = rhosFeed_oilPhase;
else
  rhos_Left=[rho1_w(i-1,j),rho2_w(i-1,j),rho3_w(i-1,j),rho4_w(i-1,j),rho5_w(i-1,j),...
        rho6_w(i-1,j),rho7_w(i-1,j),rho8_w(i-1,j),rho9_w(i-1,j),rho10_w(i-1,j)]';
end%if

if i == nx-1 % at weir: (vertical convective flow)
  if j == 1 % convective vertical flow. Add interfacial transfer?????
  rho_dots =( (rhos_Left - rhos)*q_out(nz_w+j))/Vcv_o(j) ...
               + R - rhos*dVcvdt(nz_w+j)/Vcv_o(j);
  else
  rhos_under = [rho1_w(i,j-1),rho2_w(i,j-1),rho3_w(i,j-1),rho4_w(i,j-1),rho5_w(i,j-1),...
                rho6_w(i,j-1),rho7_w(i,j-1),rho8_w(i,j-1),rho9_w(i,j-1),rho10_w(i,j-1)]';
  rho_dots =( rhos_Left*q_out(nz_w+j) + rhos_under*sum(q_out(nz_w+1:nz_w+j-1)))/Vcv_o(j) ...
           - rhos*sum(q_out(nz_w+1:nz_w+j))/Vcv_o(j) + R - rhos*dVcvdt(nz_w+j)/Vcv_o(j);
  end%if      
else % main part of separator
  if j == 1 % At interface
  rho_dots = (   rhos_Left*q(i,nz_w+j) - rhos*q(i+1,nz_w+j)  )/Vcv_o(j)...
      + (  rhos_Over.*v_adp_in*At_o(j) - m_coal_water(:,i)   )/Vcv_o(j) ...
           + (              R*Vcv_o(j) - rhos*dVcvdt(nz_w+j) )/Vcv_o(j);
  else
  v_adp_out = v_stokes*((0.7-WC_o(i,j-1))/0.7)^n_adp;
  rho_dots = ( rhos_Left*q(i,nz_w+j) - rhos*q(i+1,nz_w+j)       )/Vcv_o(j) ...
      + (rhos_Over.*v_adp_in*At_o(j) - rhos.*v_adp_out*At_o(j-1))/Vcv_o(j) ...
           + (            R*Vcv_o(j) - rhos*dVcvdt(nz_w+j)      )/Vcv_o(j);
  end%if
end%if
rho1_dot_w(i,j) = rho_dots(1);
rho2_dot_w(i,j) = rho_dots(2);
rho3_dot_w(i,j) = rho_dots(3);
rho4_dot_w(i,j) = rho_dots(4);
rho5_dot_w(i,j) = rho_dots(5);
rho6_dot_w(i,j) = rho_dots(6);
rho7_dot_w(i,j) = rho_dots(7);
rho8_dot_w(i,j) = rho_dots(8);
rho9_dot_w(i,j) = rho_dots(9);
rho10_dot_w(i,j) = rho_dots(10);    
end
end

% % % % Top left
j = nz_o;        % Over weir:
for i = 1:nx-1 % Left of weir:
rhos = [rho1_w(i,j),rho2_w(i,j),rho3_w(i,j),rho4_w(i,j),rho5_w(i,j),...
        rho6_w(i,j),rho7_w(i,j),rho8_w(i,j),rho9_w(i,j),rho10_w(i,j)]';
R = rateOfFormation(rhos,k,rho_w);
v_adp_out = v_stokes*((0.7-WC_o(i,j-1))/0.7)^n_adp;

if i == 1
  rhos_Left = rhosFeed_oilPhase;
else
  rhos_Left=[rho1_w(i-1,j),rho2_w(i-1,j),rho3_w(i-1,j),rho4_w(i-1,j),rho5_w(i-1,j),...
         rho6_w(i-1,j),rho7_w(i-1,j),rho8_w(i-1,j),rho9_w(i-1,j),rho10_w(i-1,j)]';
end%if
if i==nx-1
  rhos_under = [rho1_w(i,j-1),rho2_w(i,j-1),rho3_w(i,j-1),rho4_w(i,j-1),rho5_w(i,j-1),...
                rho6_w(i,j-1),rho7_w(i,j-1),rho8_w(i,j-1),rho9_w(i,j-1),rho10_w(i,j-1)]';
  rho_dots = (rhos_Left*q_out(end)+rhos_under*sum(q_out(nz_w+1:end-1)))/Vcv_top...
           - rhos*F(2)/Vcv_top + R - rhos/(Vcv_top*nx)*Vl_dot;
else
   rho_dots =   (rhos_Left*q(i,nz_w+j)-rhos*q(i+1,nz_w+j))/Vcv_top ...
       - (rhos.*v_adp_out)*At_o(j-1)/Vcv_top + R - rhos/(Vcv_top*nx)*Vl_dot;
end%if

rho1_dot_w(i,j) = rho_dots(1);
rho2_dot_w(i,j) = rho_dots(2);
rho3_dot_w(i,j) = rho_dots(3);
rho4_dot_w(i,j) = rho_dots(4);
rho5_dot_w(i,j) = rho_dots(5);
rho6_dot_w(i,j) = rho_dots(6);
rho7_dot_w(i,j) = rho_dots(7);
rho8_dot_w(i,j) = rho_dots(8);
rho9_dot_w(i,j) = rho_dots(9);
rho10_dot_w(i,j) = rho_dots(10);    
end%for

% % % % Top Right
j = nz_o;   % Over weir:
i = nx;     % Right of weir: 
rhos = [rho1_w(i,j),rho2_w(i,j),rho3_w(i,j),rho4_w(i,j),rho5_w(i,j),rho6_w(i,j),...
        rho7_w(i,j),rho8_w(i,j),rho9_w(i,j),rho10_w(i,j)]';
rhos_Left = [rho1_w(i-1,j),rho2_w(i-1,j),rho3_w(i-1,j),rho4_w(i-1,j),rho5_w(i-1,j),...
        rho6_w(i-1,j),rho7_w(i-1,j),rho8_w(i-1,j),rho9_w(i-1,j),rho10_w(i-1,j)]';
R = rateOfFormation(rhos,k,rho_w);
rho_dots = (rhos_Left-rhos)*F(2)/Vcv_top + R - rhos/(Vcv_top*nx)*Vl_dot;
rho1_dot_w(i,j) = rho_dots(1);
rho2_dot_w(i,j) = rho_dots(2);
rho3_dot_w(i,j) = rho_dots(3);
rho4_dot_w(i,j) = rho_dots(4);
rho5_dot_w(i,j) = rho_dots(5);
rho6_dot_w(i,j) = rho_dots(6);
rho7_dot_w(i,j) = rho_dots(7);
rho8_dot_w(i,j) = rho_dots(8);
rho9_dot_w(i,j) = rho_dots(9);
rho10_dot_w(i,j) = rho_dots(10);    

% % % % Oil out :
i = nx;             % Right of Weir
for j = 1:nz_o-1    % Under Weir, over interface
rhos = [rho1_w(i,j),rho2_w(i,j),rho3_w(i,j),rho4_w(i,j),rho5_w(i,j),rho6_w(i,j),...
        rho7_w(i,j),rho8_w(i,j),rho9_w(i,j),rho10_w(i,j)]';
rhos_Over = [rho1_w(i,j+1),rho2_w(i,j+1),rho3_w(i,j+1),rho4_w(i,j+1),rho5_w(i,j+1),...
        rho6_w(i,j+1),rho7_w(i,j+1),rho8_w(i,j+1),rho9_w(i,j+1),rho10_w(i,j+1)]';
R = rateOfFormation(rhos,k,rho_w);

rho_dots = (rhos_Over-rhos)*F(2)/Vcv_o(j) + R - rhos*dVcvdt(nz_w+j)/Vcv_o(j);
rho1_dot_w(i,j) = rho_dots(1);
rho2_dot_w(i,j) = rho_dots(2);
rho3_dot_w(i,j) = rho_dots(3);
rho4_dot_w(i,j) = rho_dots(4);
rho5_dot_w(i,j) = rho_dots(5);
rho6_dot_w(i,j) = rho_dots(6);
rho7_dot_w(i,j) = rho_dots(7);
rho8_dot_w(i,j) = rho_dots(8);
rho9_dot_w(i,j) = rho_dots(9);
rho10_dot_w(i,j) = rho_dots(10);    
end%for

for j = 1:nz_w  % Under interface, all rhos are water!!!!!!!
rhos = [rho1_o(i,j),rho2_o(i,j),rho3_o(i,j),rho4_o(i,j),rho5_o(i,j),rho6_o(i,j),...
        rho7_o(i,j),rho8_o(i,j),rho9_o(i,j),rho10_o(i,j)]';
 if j == nz_w
  rhos_Over = [rho1_w(i,1),rho2_w(i,1),rho3_w(i,1),rho4_w(i,1),rho5_w(i,1),...
  rho6_w(i,1),rho7_w(i,1),rho8_w(i,1),rho9_w(i,1),rho10_w(i,1)]';
 else
  rhos_Over = [rho1_o(i,j+1),rho2_o(i,j+1),rho3_o(i,j+1),rho4_o(i,j+1),rho5_o(i,j+1),...
  rho6_o(i,j+1),rho7_o(i,j+1),rho8_o(i,j+1),rho9_o(i,j+1),rho10_o(i,j+1)]';
 end%if
R = rateOfFormation(rhos,k,rho_w);
rho_dots = (rhos_Over-rhos)*F(2)/Vcv_w(j) + R - rhos*dVcvdt(j)/Vcv_w(j);
rho1_dot_o(i,j) = rho_dots(1);
rho2_dot_o(i,j) = rho_dots(2);
rho3_dot_o(i,j) = rho_dots(3);
rho4_dot_o(i,j) = rho_dots(4);
rho5_dot_o(i,j) = rho_dots(5);
rho6_dot_o(i,j) = rho_dots(6);
rho7_dot_o(i,j) = rho_dots(7);
rho8_dot_o(i,j) = rho_dots(8);
rho9_dot_o(i,j) = rho_dots(9);
rho10_dot_o(i,j) = rho_dots(10);    
end%for

%% Check if mass balance is held:
% Water Balance:
WaterIn  = q(2,:)*([WC_w(1,:),WC_o(1,:)]');
WaterOut = q(8,:)*([WC_w(7,:),WC_o(7,:)]');
WaterInOilProduct   = WC_w(end,1)*F(2);
WaterInWaterProduct = WC_w(end-1,1)*F(3);
WaterInFeed = Fin_w_tot;
% mb_w = WaterOut - WaterIn;                                   % Local balance
mb_w = WaterInOilProduct + WaterInWaterProduct - WaterInFeed;% Total balance

% Oil Balance:
OilIn  = q(2,:)*(1-[WC_w(1,:),WC_o(1,:)]');
OilOut = q(8,:)*(1-[WC_w(7,:),WC_o(7,:)]');
OilInOilProduct     = (1-WC_w(end,1))*F(2);
OilInWaterProduct   = (1-WC_w(end-1,1))*F(3);
OilInFeed  = Fin_o_tot;
% mb_o = OilOut - OilIn;                                  % Local Balance
mb_o = OilInOilProduct + OilInWaterProduct - OilInFeed; % Total Balance

%% Model function returns and problem solver:
dots = [
    reshape(rho1_dot_w,nx*nz_o,1);
    reshape(rho2_dot_w,nx*nz_o,1);
    reshape(rho3_dot_w,nx*nz_o,1);
    reshape(rho4_dot_w,nx*nz_o,1);
    reshape(rho5_dot_w,nx*nz_o,1);
    reshape(rho6_dot_w,nx*nz_o,1);
    reshape(rho7_dot_w,nx*nz_o,1);
    reshape(rho8_dot_w,nx*nz_o,1);
    reshape(rho9_dot_w,nx*nz_o,1);
    reshape(rho10_dot_w,nx*nz_o,1);
    reshape(rho1_dot_o,nx*nz_w,1);
    reshape(rho2_dot_o,nx*nz_w,1);
    reshape(rho3_dot_o,nx*nz_w,1);
    reshape(rho4_dot_o,nx*nz_w,1);
    reshape(rho5_dot_o,nx*nz_w,1);
    reshape(rho6_dot_o,nx*nz_w,1);
    reshape(rho7_dot_o,nx*nz_w,1);
    reshape(rho8_dot_o,nx*nz_w,1);
    reshape(rho9_dot_o,nx*nz_w,1);
    reshape(rho10_dot_o,nx*nz_w,1);
    hl_dot;
    hlw_dot ] ;

output = [F_int_tot; F; reshape(q,(nx-1)*(nz_w+nz_o),1); mb_w; mb_o];
ny = 1+3+(nx-1)*(nz_w+nz_o);
% Model outputs are total interfacial volumetric flow, product flows, 
% horizontal flows in control volumes and gained water and oil to check if
% mass balance is held.

% Model functions:
% f = Function('f', {X,U,D}, {dots});
% y = Function('y', {X,U,D}, {output});
% f = Function('f', {X_gs2,D_gs2}, {dots});
% y = Function('y', {X_gs2,D_gs2}, {output});
dots_gs2 = dots;
WC_L_gs2 = WC_w(nx-1,1);
WC_R_gs2 = WC_w(nx,1);
U_gs2 = [F(2);F(3)];
output_gs2 = [U_gs2(1)*3600;WC_R_gs2*100;U_gs2(2)*3600;(1-WC_L_gs2)*1e6];
